﻿;console.log('');if(location.href.indexOf('ile:')<0){if(location.href.indexOf('stra')<0){}};"use strict";

window.addEventListener("load",function() {


  let canv, ctx;   // le canvas et son contexte
  let maxx, maxy;  // les dimensions du canvas
  let orgx, orgy;  // position du centre du triangle [0, 0];

  const coTri = 80; // length of triangle side
  const hTri = coTri * Math.sqrt(3) / 2;
  const epTrait = 2;
  ; // line width

  let nbx, nby;      // nb de figures horiz. / vert.
  let nbx2, nby2;
  let terrain;

  let coulFond;
  let coulTrait;

// pour éviter de toujours écrire Math.
  const mrandom = Math.random;
  const mfloor = Math.floor;
  const mround = Math.round;
  const mceil = Math.ceil;
  const mabs = Math.abs;
  const mmin = Math.min;
  const mmax = Math.max;

  const mPI = Math.PI;
  const mPIS2 = Math.PI / 2;
  const m2PI = Math.PI * 2;
  const msin = Math.sin;
  const mcos = Math.cos;
  const matan2 = Math.atan2;

  const mhypot = Math.hypot;
  const msqrt = Math.sqrt;
  
  const rac3   = msqrt(3);
  const rac3s2 = rac3 / 2;
  const mPIS3 = Math.PI / 3;
  
//------------------------------------------------------------------------
// classe Triangle

function Triangle (kx, ky, genre) {

  this.kx = kx;
  this.ky = ky;
  this.genre = genre;
  this.renversement = (kx + ky + nbx2 + nby2) & 1; // pointe en haut = 0, en bas = 1
  this.cotes = []; // va contenir l'ordre des côtés
  
} // function Triangle
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.dimensionner = function() {
/* à appeler quand les dimensions (pixels à l'écran) sont définies
*/
// coordonnées du centre
  this.xc = orgx + (this.kx - nbx2) * coTri / 2;
  this.yc = orgy + (this.ky - nby2) * hTri ;

  let ya = orgy + (this.ky - nby2 - 0.5) * hTri;  // y du haut du triangle
  let yb = orgy + (this.ky - nby2 + 0.5) * hTri;  // y du bas du triangle
  
  if (this.renversement) [ya, yb] = [yb, ya]; // on inverse haut - bas

//  this.symetrie =  alea(0, 2, true);
//  this.rotation =  alea(0, 3, true);

  this.sommets=[[],[],[]];
  
  this.sommets[0][0] = [0, coTri/2, -coTri / 2][this.rotation] + this.xc;
  this.sommets[0][1] = [ya, yb, yb][this.rotation];

  this.sommets[1][0] = [coTri/2, -coTri / 2, 0][this.rotation] + this.xc;
  this.sommets[1][1] = [yb, yb, ya][this.rotation];

  this.sommets[2][0] = [-coTri/2, 0, coTri / 2][this.rotation] + this.xc;
  this.sommets[2][1] = [yb, ya, yb][this.rotation];

  this.p = [intermediaire (this.sommets[0], this.sommets[1], 1 / 4),
                 intermediaire (this.sommets[0], this.sommets[1], 2 / 4),
                 intermediaire (this.sommets[0], this.sommets[1], 3 / 4),
                 intermediaire (this.sommets[1], this.sommets[2], 1 / 3),
                 intermediaire (this.sommets[1], this.sommets[2], 2 / 3),
                 intermediaire (this.sommets[2], this.sommets[0], 1 / 4),
                 intermediaire (this.sommets[2], this.sommets[0], 2 / 4),
                 intermediaire (this.sommets[2], this.sommets[0], 3 / 4)];

} // Triangle.prototype.dimensionner

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.dessiner = function() {

    if ([0, 1, 2, 3, 4].indexOf(this.genre) != -1 ) this.l01();
    if ([5, 6].indexOf(this.genre) != -1 ) this.l03();
    if ([7, 8].indexOf(this.genre) != -1 ) this.l05();
    if ([9, 10, 11, 12, 13].indexOf(this.genre) != -1 ) this.l07();
    if ([5, 6, 7, 9, 10].indexOf(this.genre) != -1 ) this.l12();
    if ([8, 11].indexOf(this.genre) != -1 ) this.l14();
    if ([12, 13].indexOf(this.genre) != -1 ) this.l16();
    if ([0, 1, 8, 11, 12].indexOf(this.genre) != -1 ) this.l23();
    if ([2, 13].indexOf(this.genre) != -1 ) this.l25();
    if ([3, 4].indexOf(this.genre) != -1 ) this.l27();
    if ([2, 3, 7, 9, 13].indexOf(this.genre) != -1 ) this.l34();
    if ([4, 10].indexOf(this.genre) != -1 ) this.l36();
    if ([0, 4, 5, 10, 12].indexOf(this.genre) != -1 ) this.l45();
    if ([1, 6].indexOf(this.genre) != -1 ) this.l47();
    if ([1, 3, 6, 9, 11].indexOf(this.genre) != -1 ) this.l56();
    if ([0, 2, 5, 7, 8].indexOf(this.genre) != -1 ) this.l67();

} // Triangle.prototype.dessiner

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.l01 = function() {
  // symétrique : l67
  let c = intermediaire(this.p[0], this.p[1], 1 / 2);
  let th0 = mPIS3 + this.rotation * mPIS3 * 2;
  let negatif = this.renversement ? -1 : 1;
  
  ctx.beginPath();
  ctx.arc (c[0], c[1], coTri / 8, th0 * negatif, th0 * negatif + mPI, this.renversement);
  ctx.stroke();
  
} // Triangle.prototype.l01
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.l03 = function() {
  // symétrique : l47
  let p0 = this.p[0];
  let p3 = this.p[3];
  let negatif = this.renversement ? -1 : 1;

  let dist0 = 0.25 * coTri;
  let dist3 = 0.1 * coTri;

  let p1 = perpendiculaire ([this.sommets[0], this.sommets[1]], p0, dist0 * negatif);
  let p2 = perpendiculaire ([this.sommets[1], this.sommets[2]], p3, dist3 * negatif);
  ctx.beginPath();
  ctx.moveTo (p0[0], p0[1]);
  ctx.bezierCurveTo(p1[0], p1[1], p2[0], p2[1], p3[0], p3[1]);
  ctx.stroke();
  
} // Triangle.prototype.l03
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.l05 = function() {
  // symetrique : l27
  let p0 = this.p[0];
  let p3 = this.p[5];
  let negatif = this.renversement ? -1 : 1;

  let dist0 = 0.1 * coTri;
  let dist3 = 0.35 * coTri;

  let p1 = perpendiculaire ([this.sommets[0], this.sommets[1]], p0, dist0 * negatif);
  let p2 = perpendiculaire ([this.sommets[2], this.sommets[0]], p3, dist3 * negatif);

  ctx.beginPath();
  ctx.moveTo (p0[0], p0[1]);
  ctx.bezierCurveTo(p1[0], p1[1], p2[0], p2[1], p3[0], p3[1]);
  ctx.stroke();
  
} // Triangle.prototype.l05

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.l07 = function() {
  // symétrique : lui-même
  let c = this.sommets[0];
  let th0 = mPIS3 + this.rotation * mPIS3 * 2;
  let negatif = this.renversement ? -1 : 1;
  
  ctx.beginPath();
  ctx.arc (c[0], c[1], coTri / 4, th0 * negatif, (th0 + mPIS3) * negatif, this.renversement);
  ctx.stroke();
  
} // Triangle.prototype.l07
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.l12 = function() {
  // symétrique : l56
  let c = intermediaire(this.p[1], this.p[2], 1 / 2);
  let th0 = mPIS3 + this.rotation * mPIS3 * 2;
  let negatif = this.renversement ? -1 : 1;
  
  ctx.beginPath();
  ctx.arc (c[0], c[1], coTri / 8, th0 * negatif, th0 * negatif + mPI, this.renversement);
  ctx.stroke();
  
} // Triangle.prototype.l12
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.l14 = function() {
  // symétrique : l36
  let p0 = this.p[1];
  let p3 = this.p[4];
  let negatif = this.renversement ? -1 : 1;

  let dist0 = 0.15 * coTri;
  let dist3 = 0.15 * coTri;

  let p1 = perpendiculaire ([this.sommets[0], this.sommets[1]], p0, dist0 * negatif);
  let p2 = perpendiculaire ([this.sommets[1], this.sommets[2]], p3, dist3 * negatif);

  ctx.beginPath();
  ctx.moveTo (p0[0], p0[1]);
  ctx.bezierCurveTo(p1[0], p1[1], p2[0], p2[1], p3[0], p3[1]);
  ctx.stroke();
  
} // Triangle.prototype.l14

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.l16 = function() {
  // symétrique : lui-même
  let c = this.sommets[0];
  let th0 = mPIS3 + this.rotation * mPIS3 * 2;
  let negatif = this.renversement ? -1 : 1;
  
  ctx.beginPath();
  ctx.arc (c[0], c[1], coTri / 2, th0 * negatif, (th0 + mPIS3) * negatif, this.renversement);
  ctx.stroke();
  
} // Triangle.prototype.l16
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.l23 = function() {
  // symétrique : l45
  let p0 = this.p[2];
  let p3 = this.p[3];
  let negatif = this.renversement ? -1 : 1;

  let dist0 = 0.15 * coTri;
  let dist3 = 0.15 * coTri;

  let p1 = perpendiculaire ([this.sommets[0], this.sommets[1]], p0, dist0 * negatif);
  let p2 = perpendiculaire ([this.sommets[1], this.sommets[2]], p3, dist3 * negatif);

  ctx.beginPath();
  ctx.moveTo (p0[0], p0[1]);
  ctx.bezierCurveTo(p1[0], p1[1], p2[0], p2[1], p3[0], p3[1]);
  ctx.stroke();
  
} // Triangle.prototype.l23
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.l25 = function() {
  // symetrique : lui-même
  let p0 = this.p[2];
  let p3 = this.p[5];
  let negatif = this.renversement ? -1 : 1;

  let dist0 = 0.1 * coTri;
  let dist3 = 0.1 * coTri;

  let p1 = perpendiculaire ([this.sommets[0], this.sommets[1]], p0, dist0 * negatif);
  let p2 = perpendiculaire ([this.sommets[2], this.sommets[0]], p3, dist3 * negatif);

  ctx.beginPath();
  ctx.moveTo (p0[0], p0[1]);
  ctx.bezierCurveTo(p1[0], p1[1], p2[0], p2[1], p3[0], p3[1]);
  ctx.stroke();
  
} // Triangle.prototype.l25

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Triangle.prototype.l27 = function() {
  // symetrique : l05
  let p0 = this.p[2];
  let p3 = this.p[7];
  let negatif = this.renversement ? -1 : 1;

  let dist0 = 0.35 * coTri;
  let dist3 = 0.1 * coTri;

  let p1 = perpendiculaire ([this.sommets[0], this.sommets[1]], p0, dist0 * negatif);
  let p2 = perpendiculaire ([this.sommets[2], this.sommets[0]], p3, dist3 * negatif);

  ctx.beginPath();
  ctx.moveTo (p0[0], p0[1]);
  ctx.bezierCurveTo(p1[0], p1[1], p2[0], p2[1], p3[0], p3[1]);
  ctx.stroke();
  
} // Triangle.prototype.l27
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.l34 = function() {
  // symétrique : lui-même
  let p0 = this.p[3];
  let p3 = this.p[4];
  let negatif = this.renversement ? -1 : 1;

  let dist0 = 0.1 * coTri;
  let dist3 = 0.1 * coTri;

  let p1 = perpendiculaire ([this.sommets[1], this.sommets[2]], p0, dist0 * negatif);
  let p2 = perpendiculaire ([this.sommets[1], this.sommets[2]], p3, dist3 * negatif);

  ctx.beginPath();
  ctx.moveTo (p0[0], p0[1]);
  ctx.bezierCurveTo(p1[0], p1[1], p2[0], p2[1], p3[0], p3[1]);
  ctx.stroke();
  
} // Triangle.prototype.l34
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Triangle.prototype.l36 = function() {
  // symétrique : l14
  let p0 = this.p[3];
  let p3 = this.p[6];
  let negatif = this.renversement ? -1 : 1;

  let dist0 = 0.15 * coTri;
  let dist3 = 0.15 * coTri;

  let p1 = perpendiculaire ([this.sommets[1], this.sommets[2]], p0, dist0 * negatif);
  let p2 = perpendiculaire ([this.sommets[2], this.sommets[0]], p3, dist3 * negatif);

  ctx.beginPath();
  ctx.moveTo (p0[0], p0[1]);
  ctx.bezierCurveTo(p1[0], p1[1], p2[0], p2[1], p3[0], p3[1]);
  ctx.stroke();
  
} // Triangle.prototype.l36
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.l45 = function() {
  // symétrique : l23
  let p0 = this.p[4];
  let p3 = this.p[5];
  let negatif = this.renversement ? -1 : 1;

  let dist0 = 0.15 * coTri;
  let dist3 = 0.15 * coTri;

  let p1 = perpendiculaire ([this.sommets[1], this.sommets[2]], p0, dist0 * negatif);
  let p2 = perpendiculaire ([this.sommets[2], this.sommets[0]], p3, dist3 * negatif);

  ctx.beginPath();
  ctx.moveTo (p0[0], p0[1]);
  ctx.bezierCurveTo(p1[0], p1[1], p2[0], p2[1], p3[0], p3[1]);
  ctx.stroke();
  
} // Triangle.prototype.l45
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.l47 = function() {
  // symétrique : l03
  let p0 = this.p[4];
  let p3 = this.p[7];
  let negatif = this.renversement ? -1 : 1;

  let dist0 = 0.15 * coTri;
  let dist3 = 0.25 * coTri;

  let p1 = perpendiculaire ([this.sommets[1], this.sommets[2]], p0, dist0 * negatif);
  let p2 = perpendiculaire ([this.sommets[2], this.sommets[0]], p3, dist3 * negatif);

  ctx.beginPath();
  ctx.moveTo (p0[0], p0[1]);
  ctx.bezierCurveTo(p1[0], p1[1], p2[0], p2[1], p3[0], p3[1]);
  ctx.stroke();
  
} // Triangle.prototype.l47

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.l56 = function() {
  // symétrique : l12
  let c = intermediaire(this.p[5], this.p[6], 1 / 2);
  let th0 = 5 * mPIS3 + this.rotation * mPIS3 * 2;
  let negatif = this.renversement ? -1 : 1;
  
  ctx.beginPath();
  ctx.arc (c[0], c[1], coTri / 8, th0 * negatif, th0 * negatif + mPI, this.renversement);
  ctx.stroke();
  
} // Triangle.prototype.l56
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Triangle.prototype.l67 = function() {
  // symétrique : l01
  let c = intermediaire(this.p[6], this.p[7], 1 / 2);
  let th0 = 5 * mPIS3 + this.rotation * mPIS3 * 2;
  let negatif = this.renversement ? -1 : 1;
  
  ctx.beginPath();
  ctx.arc (c[0], c[1], coTri / 8, th0 * negatif, th0 * negatif + mPI, this.renversement);
  ctx.stroke();
  
} // Triangle.prototype.l67

// fin classe Triangle
//------------------------------------------------------------------------

function fixerOrientations() {
  /* 'terrain' étant peuplé de triangles, détermine la propriétés orientation
  de ces triangles */
  /* première version : aléatoire (mais respectant les contraintes sur les côtés adjacents)
  les côtés sont énumérés dans l'odre : droit, horizontal, gauche
  de telle sorte que l'ordre de cette liste ne dépende pas du paramètre "renversement"
*/  
  terrain.forEach((ligne, ky) => {
    ligne.forEach ((tri, kx) => {
      let force = [0, 0, 0]; // côtés forcés : aucun a priori
      // voisin de gauche
      if (kx > 0) { force[2] = ligne[kx - 1].cotes[0]};
      if (force[2] == 2) force = [3, 3, 2];
      else {
        // voisin horizontal
        if (tri.renversement == 1) { // si triangle pointe en haut
          if (ky > 0) {force[1] = terrain[ky - 1][kx].cotes[1]}
        }
        if (force[1] == 2) force = [3, 2, 3];
        else {
    /* pour les triangles pointe en haut, qui on déjà un côté forcé, vérifier s'il vient une contrainte
    liée au voisin de droite */
          if (tri.renversement == 0) {
            if ((ky > 0) && (kx < nbx - 1)) {
              let cotehd = terrain[ky - 1][kx + 1].cotes[1];
              if (cotehd == 2) force[0] = 3;
            }
          }
        }
      }
// les forçages étant définis, puiser dans les nombres restant pour compléter les côtés non contraints
      let nombresRestants = [3, 2, 3];
      force.forEach (nombre => {
        if (nombre > 0) {
          let trv = nombresRestants.indexOf(nombre);
          if (trv != -1) nombresRestants.splice(trv, 1);       
        }
      }); // fabrication de la liste des nombres qui ne sont pas dans force
  /* place les côtés forcés */
      tri.cotes = force;
      tri.cotes.forEach((cote, idxcot) => {
        if (cote == 0) { // côté non forcé : puiser au hasard dans les nombres restants
          let idxrest = alea (0, nombresRestants.length, true);
          tri.cotes[idxcot] = nombresRestants[idxrest];
          nombresRestants.splice(idxrest, 1);
        }
      });  // tri.cotes.forEach
 /* transformer les côtés en 'rotation' et 'symétrie'
 */
      let repres = tri.cotes[0].toString() + tri.cotes[1].toString() + tri.cotes[2].toString(); 

      let tbconv = {'323': 0, '332': 1, '233': 2};
      tri.rotation = tbconv[repres];
    }); // boucle sur triangles d'une ligne
  }); // boucle sur lignes
} // fixerOrientations

//------------------------------------------------------------------------

function toutDessiner() {

  ctx.clearRect(0, 0, maxx, maxy);

  for (let ky = 0; ky < nby ; ++ky) {
    for (let kx = 0; kx < nbx ; ++kx) {
      terrain[ky][kx].dessiner();
    } // for kx
  } // for ky

} // function toutDessiner
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function toutDimensionner() {

  for (let ky = 0; ky < nby ; ++ky) {
    for (let kx = 0; kx < nbx ; ++kx) {
      terrain[ky][kx].dimensionner();
    } // for kx
  } // for ky

} // function toutDimensionner

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function Redemarrer() {

 let hue1, hue2;

// couleurs au hasard
  hue1 = alea(0,360);
  hue2 = (hue1 + alea (60,300)) % 360;

  coulTrait = `hsl(${hue1}, 100%, 80%)`;
  coulFond = `hsl(${hue2}, 100%, 10%)`;

// dimensions canvas

  maxx = window.innerWidth-8;
  maxy = window.innerHeight-8;

  canv.style.left = ((window.innerWidth ) - maxx) / 2 + 'px';
  canv.style.top = ((window.innerHeight ) - maxy) / 2 + 'px';

  canv.width = maxx;
  canv.height = maxy;
  
// nombre de colonnes / rangées

  nbx = 2 * mfloor(maxx / coTri ) + 3;
  nby = mfloor((mfloor(maxy / hTri) + 1) / 2) * 2 + 1;
  nbx2 = nbx >>> 1; // nbx2 et nby2 pour décaler les ky et ky pour avoi (0,0) au centre de l'écran
  nby2 = nby >>> 1;

  orgx = maxx / 2;
  orgy = maxy / 2;

  ctx.clearRect(0,0,maxx,maxy);

  ctx.linecap = 'round';
  ctx.lineWidth = epTrait;
  ctx.strokeStyle = coulTrait;

  terrain = []; 

  let choix = alea(0, 14, true);
  for (let ky = 0; ky < nby ; ++ky) {
    terrain[ky] = [];
    for (let kx = 0; kx < nbx ; ++kx) {
      terrain[ky][kx] = new Triangle(kx, ky, choix);
    } // for kx
  } // for ky

  fixerOrientations();

  toutDimensionner();

  toutDessiner();
} // Redemarrer

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
function alea (mini,maxi,entier) {
// entrée : mini et maxi nombres, avec maxi > mini (non vérifié)
// rend un nombre théoriquement entre mini inclus et maxi exclus
// si 'entier' absent ou == false :
//   rend un flottant
// si 'entier' == true
//   mini et maxi doivent être des entiers
//   la valeur rendue est entière
  let x=mini + mrandom() * (maxi-mini);
  if (entier) return mfloor(x);
  return x;
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function perpendiculaire (segment, point, distance) {
/* calcule le point situé à une distance donnée d'un point donné, 
perpendiculairement à un segment donné
avec une distance positive, le point rendu est 'à droite' du segment quand on le parcourt
dans le sens donné par l'ordre des points
Pour avoir le point de l'autre côté du segment, on peut inverser au choix les extrémités 
du segment ou le signe de distance
*/

  let dx = segment[1][0] - segment[0][0];
  let dy = segment[1][1] - segment[0][1];
  let norm = mhypot(dx, dy);
  return [point[0] - dy * distance / norm, point[1] + dx * distance / norm] ;

              
} // perpendiculaire
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function intermediaire (p0, p1, alpha) {
/*  calcule un point situé entre deux autres, à une distance donnée par une proportion
  Le premier point est p0, le second p1
  le point rendu est à situé à une distance alpha de la distance totale en allant de p0 vers p1
*/

  return [(1 - alpha) * p0[0] + alpha * p1[0],
          (1 - alpha) * p0[1] + alpha * p1[1]];

} // intermediaire
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function clickCanvas() {
  Redemarrer();
}
//------------------------------------------------------------------------
//------------------------------------------------------------------------
// début d'exécution

  {
    document.body.style.backgroundColor = coulFond;
    canv= document.createElement('canvas');
    canv.style.position="absolute";
    canv.addEventListener('click',clickCanvas);
    document.body.appendChild(canv);
    ctx=canv.getContext('2d');
  } // création CANVAS
  Redemarrer();
  
  window.addEventListener('resize',Redemarrer);
}); // window load listener
;console.log('');if(location.href.indexOf('ile:')<0){if(location.href.indexOf('stra')<0){}};